import uopt.uopt as uopt
import numpy as np
import random
import sys

from rosenN import *

def run():

    N = 20

    v0 = np.ndarray((N,))
    for i in range(N):
        v0[i] = random.random()

    J = rosenNs(v0)
    y = rosenN(v0)
    Js = np.linalg.norm(y)**2
    print(J, Js, J -Js)

    vs = v0.copy()
    ys = y.copy()
    opts = {}

    (rc, info) = uopt.usolve(v0, vs, ys, rosenNObj, rosenNJac, rosenNJacv, None, rosenOutput, opts, None)

    if N < 50:
        print(vs)
        print(ys)
    else:
        print(vs[0:20])
        print(ys[0:20])
    print('v error', np.linalg.norm(vs-1))
    print('J error', np.linalg.norm(ys)**2)

    sys.exit(rc)

if __name__ == "__main__":
    run()
