import uopt.uopt as uopt
import numpy as np
import random
import sys

from rosenNfd import *

def run():

    N = 20

    v0 = np.ndarray((N,))
    for i in range(N):
        v0[i] = random.random()

    J = rosenNs(v0)
    y = rosenN(v0)
    Js = np.linalg.norm(y)**2
    print(J, Js, J -Js)

    vs = v0.copy()
    ys = y.copy()
    opts = {'tolGradAbs': -1, 'tolGradRel': -1, 'tolEnhAbs': 2e-8}

    (rc, info) = uopt.usolve(v0, vs, ys, rosenNObj, None, rosenNJacv, rosenNJacTv, rosenOutput, opts, None)

    print(rc, info)
    print(vs)
    print(ys)
    status = info['status']
    if status['exit'] == 'search failure':
        if float(status['J']) < 1e-6:
            print('search failure is OK if J is small')
            rc = 0

    sys.exit(rc)

if __name__ == "__main__":
    run()
