library(uoptr)
library(adr)

myuopt <- uoptCreate()
luopt <- myuopt$uopt

obj <- function(x) {
    N <- length(x)
    sum((1 - x[-N])^2 + 100 * (x[-1] - x[-N]^2)^2)
}

N <- 20

v0  <- array(rnorm(1:N)*10, c(1, N))

J0 <- obj(v0)

opts <- list(maxit=1000, tolObjAbs=1e-7, sdirs=8,
             cgtol=1e-3,
             trace=0x3, saveplots=1)

vs <- luopt(v0,
           f = obj,
           g = function(x)
               adrDiffRev(obj, list(x)),
           Hv = function(x, v)
             adrHessRev(obj, list(x), V=v),
           H = NULL,
           s = function(x, status) {
               if (TRUE) {
                 uoptShowState(status)
               }
               0
           },
           options = opts)

#save(myuopt, file=sprintf('myuopt-Hessv-%d.Rdat', opts$sdirs))
#r <- uoptReport(myuopt)
#m <- uoptMovie(myuopt)
