library(uoptr)
library(adr)

myuopt <- uoptCreate()
luopt <- myuopt$uopt

obj <- function(x) {
    N <- length(x)
    sum((1 - x[-N])^2 + 100 * (x[-1] - x[-N]^2)^2)
}

N <- 200

v0  <- array(rnorm(1:N)*10, c(1, N))

J0 <- obj(v0)

opts <- list(maxit=4000, tolObjAbs=1e-7, sdirs=2,
             cgmode = 2, trace=0x3, saveplots=1)

vs <- luopt(v0,
           f = obj,
           g = function(x)
               adrDiffRev(obj, list(x)),
           Hv = NULL,
           H = NULL,
           s = function(x, status) {
               if (FALSE) {
                 uoptShowState(status)
               }
               0
           },
           options = opts)

#save(myuopt, file=sprintf('myuopt-cg-mode-%d.Rdat', opts$cgmode))
#r <- uoptReport(myuopt)
#m <- uoptMovie(myuopt)
