library(uoptr)
library(adr)

context('test-sphere')

test_that("Sphere 3D problem", {

    f <- obj <- function(x) {
        r  <- sqrt(sum(x^2))
        r
    }

    v0  <- array(rnorm(1:3)*1000, c(1, 3))

    f0 <- obj(v0)

    g <- function(x) {
        ## adrDiffFD(f, list(x))
        adrDiffRev(f, list(x))
    }

    H <- function(x) {
        ## adrHessFD(f, list(x))
        adrHessian(f, list(x))
    }

    shownlist <- function(status) {
        cat(paste(names(status), status, collapse=', ', sep='='))
        cat('\n')
    }

    output <- function(x, status) {
        shownlist(list(mean=mean(x), sd=sd(x), x=x))
        shownlist(status)
        0
    }

    opts <- list(sdirs=0x10, wolcheck=0, enableFallback=1, tolStepRel=0)

    vs <- uopt(v0, f, g, H, s = output, options = opts)

    vsinfo <- attr(vs, 'info')
    vsv <- c(vs)

    show(vsv)

    fs <- obj(vs)

    show(fs)

    ## shownlist(vsinfo$last)
    ## shownlist(vsinfo$exit)

    expect_true(vsinfo$status == 0)
    expect_true(norm(vs, "2") < 1e-6)

})
